#!/usr/bin/perl -w

################################################################################
# Name:        ModifyUser.cgi
# Version:     1.1
# Author:      Reinhard E. Voglmaier
#              GlaxoWellcome
#              rv33100@GlaxoWellcome.co.uk
# Date:        12.04.2000
# Description: Adds a new user account in the database
# Copyright:   GPL
################################################################################
push(@INC,".." );
require "adminDB.pm" ;
use CGI;

$Query = new CGI ;

print $Query->header(-expires=>'+1h');
print $Query->start_html(-title=>'Publisher Administration',
                         -author=>'rv33100@glaxowellcome.co.uk',
                         -onLoad=>'InitForm();',
                         -action=>$Action,
                         -script=>{ -language => 'JavaScript',
                                    -src=>'./ModifyUser.js' },
                        );
print $Query->start_multipart_form(-name=>'AdminPublisher'
                                   );

if ( $Query->path_info() =~ "Submit"  ) {
   my $NewUserId = $Query->param('NewUserId') ;
   my $NewUserName = $Query->param('NewUserName') ;
   my $Directories = $Query->param('Directories');
   &InsertValues($NewUserId,$NewUserName,$Directories) ;
} 

print "<PRE>";

print "User              : " ;
print $Query->textfield(-name=>'NewUserId',
                        -override=>1,
                        -onfocus=>'ReadOnly(this);',
                        -size=>10,
                        -maxlenght=>20
                        );
print " " ;
print $Query->textfield(-name=>'NewUserName',
                        -override=>1,
                        -size=>20,
                        -maxlenght=>30
                        );
print $Query->br();
print $Query->hidden(-name=>'Directories',
                        -override=>1,
                        -default=>''
                        );
print "Directory         : " ;
print $Query->scrolling_list(-name=> 'DirList',
                             -values=> ['DUMMYDUMMYDUMMYDUMMYDUMMYDUMMYDUMMYDUMMY'],
                             -override=>1,
                             -size=> 5 
                            );
print $Query->br();
print "&nbsp;" ;
print $Query->br();
print "<\PRE>";
print $Query->button(-name=>'DelDir',
                     -value=>'Delete Directory',
                     -onClick=>'DelSelDir();return true'
                    );
print $Query->button(-name=>'Update',
                     -value=>'Update User Data',
                     -onClick=>'InsertUser();return true'
                    );
print $Query->button(-name=>'Return',
                     -value=>'Return',
                     -onClick=>'window.close();'
                    );
print $Query->hr();
print $Query->scrolling_list(-name=>   'ScrollInodeList',
                             -values=> ['DUMMYDUMMYDUMMYDUMMYDUMMYDUMMYDUMMYDUMMY'],
                             -onChange=> 'displaySelectedInode(ScrollInodeList[ScrollInodeList.selectedIndex]);' ,
                             -size=>   5 ) ;
print "<PRE>";
print "Modification Date : " ;
print $Query->textfield(-name=>'ModDate',
                        -override=>1,
                        -size=>10,
                        -maxlenght=>10
                        );
print "<BR>";
print "Name              : " ;
print $Query->textfield(-name=>'UserId',
                        -override=>1,
                        -size=>10,
                        -maxlenght=>10
                        );
print "<BR>";
print "</PRE>";
print $Query->button(-name=>'AddDir',
                     -value=>'Add Selected Directory',
                     -onClick=>'AddDirTo(ScrollInodeList,DirList);'
                    );
print $Query->button(-name=>'AddNewDir',
                     -value=>'Add New Directory',
                     -onClick=>'DBAddDir();'
                    );
print "<BR>";

print $Query->endform();
print $Query->end_html();




sub InsertValues {
    my $Directory ;
    my $UserId = shift ;
    my $UserName = shift ;
    my $DirList = shift ;
    
    $DirList =~ s/;;$// ; 
    $writable = "yes" ;
    &open_databases($writable);
    
    @DirList = split(';;',$DirList) ;
    &delPermission($UserId);
    foreach $Directory ( @DirList ) {
       &addPermission($UserId,$Directory);
    }
    &close_databases();
    &UpdateUserForm($UserId,$UserName,$DirList) ;
}

sub UpdateUserForm {
    my ( $UserId,$UserName,$DirList) = @_ ;
    print <<END_OF_JAVASCRIPT;
    <SCRIPT LANGUAGE='JavaScript'>
             var UserId = "$UserId" ;
             var UserName = "$UserName" ;
             var DirList = "$DirList" ;
             var Parent = window.opener ;
             Parent.modUser(UserId,UserName,DirList) ;
             window.close();
    </SCRIPT>
END_OF_JAVASCRIPT
}
