#!/usr/bin/perl -w


################################################################################
# Name:        Schedule.pl
# Version:     1.1
# Author:      Reinhard E. Voglmaier
#              GlaxoWellcome
#              rv33100@GlaxoWellcome.co.uk
# Date:        12.04.2000
# Description: Schedules the at job for later execution.
# Copyright:   GPL
################################################################################
local $Debug = "true" ;
push(@INC,".." );
require "adminDB.pm" ;

use Mail::Sendmail ;
use Cwd ;

# Opens the databases
$Writable = "YESYES" ;
&open_databases($Writable) ;

# First get the job's list
################################################################################

opendir (DirHandle,$AcceptedRequests) || die "Could not open Directory $AcceptedRequests" ;
printf("Opened Directory %s\n",$AcceptedRequests) if ( $Debug ) ;
while($file=readdir(DirHandle)) {
   if ( $file=~ /^_/ ) {
     open(InFH,"<".$AcceptedRequests."/".$file) || die "Could not open Input $file in $AcceptedRequests \n" ;
     open(OutFH,">".$SchedDir."/".$file) || die "Could not open Input $file in $AcceptedRequests \n" ;
     
     print "File $file opened \n" if ( $Debug ) ;
     $Line = <InFH> ;
     ($Directory,$Type,$UserId,$UserName,$UpdatedOn) = split(";;",$Line) ;
     if ( $Directory && $UserId ) {
         $DirectoryName = &TakePhoto($Directory) ;
         if ( $DirectoryName ) {
             &SendMessage($Directory,$UserId,$UserName,$UpdatedOn) ;
             &modifyDir($Directory,$UserId,$UpdatedOn) ;
             &generate_at_job($Directory,$Type,$UserId,$UserName,$UpdatedOn,$DirectoryName) ;
             print OutFH join(";;",$Directory,$Type,$UserId,$UserName,$UpdatedOn,$DirectoryName);
         }
     } else {
         $Directory = "Unknown" if !($Directory) ;
         $UserId = "Unknown" if !($UserId);
         $UserName = "Unknown" if !($UserName) ;
         $UpdatedOn = "Unknown" if !($UpdatedOn) ;
         &SendErrorMessage($Directory,$UserId,$UserName,$UpdatedOn) ;
     }
     close(InFH);
     close(OutFH);
     unlink ( $AcceptedRequests."/".$file ) ;
   }
}

closedir(DirHandle);
# Close databases
&close_databases();




################################################################################
sub TakePhoto {
    my $Directory = shift ;
    my $DaCopiare     = "/d02/itweb2_htdocs".$Directory ;
    my $DirectoryName = $Directory ;
    my $RetValue ;

    $DirectoryName =~ s#/#_#g ;
    $DirectoryName .= ".tgz" ;
    my $Command = sprintf("(cd %s; /usr/bin/tar cf - . ) | /usr/local/bin/gzip > %s%s",
                  $DaCopiare,$DataDir,$DirectoryName);
    print $Command ;
    $RetValue = system($Command) ;
    $RetValue = 0 ;
    if ( $RetValue == 0 ) {
        return $DirectoryName ;
    } else {
        return ;
    }
}

sub CopyFile {
    my $File = shift ;
    my $From = "/d02/itweb2_htdocs".$File ;
    my $To = "/d03/itweb0_htdocs".$File ;

    copy($From,$To) ;

}

sub SendMessage {
    my($Directory,$UserId,$UserName,$UpdatedOn) = @_ ;

    $mail{From} = "Apache Web Server<".$WebMaster."\@ithp04.italy.glaxo>" ;
    $mail{To}   = $UserName."<".$UserId."\@glaxowellcome.co.uk>" ;
    $mail{Cc}   = WEBADMIN."<".$CC."\@glaxowellcome.co.uk>" ;
    $mail{Subject} = "Passaggio in Produzione - Scheduled " ;
    $mail{Smtp}    = "it1msg01.italy.glaxo" ;

    $mail{Message} = GetScheduleMessage($Directory,$UserId,$UserName,$UpdatedOn) ;
    sendmail(%mail) ;

}

sub SendErrorMessage {
    my($Directory,$UserId,$UserName,$UpdatedOn) = @_ ;

    $mail{From} = "Apache Web Server<".$WebMaster."\@ithp04.italy.glaxo>" ;
    $mail{To}   = WEBADMIN."<".$CC."\@glaxowellcome.co.uk>" ;
    $mail{Subject} = "Passaggio in Produzione - Error " ;
    $mail{Smtp}    = "it1msg01.italy.glaxo" ;

    $mail{Message} = GetScheduleErrorMessage($Directory,$UserId,$UserName,$UpdatedOn) ;
    sendmail(%mail) ;
}


sub generate_at_job {
     my ($Directory,$Type,$UserId,$UserName,$UpdatedOn,$ArchiveName)= @_ ;
     my $JobName = $ArchiveName ;
     my ($DirectoryName,$ProzessId,$SaveFile,$NewDirectory) ;

     $DirectoryName = $ArchiveName ;
     $DirectoryName =~ s/\.tgz// ;
     $JobName = cwd()."/".$AtJobDir.$DirectoryName.".sh" ;

     open(JOB,">".$JobName) || die "Could not generate at job $JobName \n" ;
     printf("JOB %s generated \n",$JobName) if ( defined($Debug));

     $ProzessId = $$ ;
     $SaveFile = $SaveDir.$ArchiveName ;

     $Directory =~ s#^/## ;
     $NewDirectory = $Directory."_new".$ProzessId ;
     print JOB <<EndOfJob;
     #!/bin/sh
     if [ ! -d $DocumentRootProd$Directory ] ; then
        echo "$DocumentRootProd$Directory does not exist"
        exit 1
     fi
     cd $DocumentRootProd$Directory
     /usr/bin/tar cf - . | /usr/local/bin/gzip > $SaveFile ;
     cd $DocumentRootProd
     mkdir $NewDirectory
     cd $NewDirectory
     /usr/local/bin/gzip -cd $DataDir$ArchiveName | /usr/bin/tar xmf -
     cd $DocumentRootProd
     mv $Directory ${Directory}_$ProzessId
     mv $NewDirectory $Directory
     rm -rf ${Directory}_$ProzessId
     rm $DataDir$ArchiveName
     echo "$Directory;;$UserId;;$UserName;;$UpdatedOn;;$DataDir${ArchiveName}" > $CommitedDir$DirectoryName
     rm $SchedDir$DirectoryName
EndOfJob

}
